%global rpcuser_uid 29
%global nfsnobody_uid 65534

Summary:		A greatly revised NFS implementation for Linux
Name:			nfs-utils
Version:		2.6.3
Release:		1%{?dist}
License:		MIT and GPLv2 and GPLv2+ and BSD
URL:			http://linux-nfs.org/
Source0:		https://www.kernel.org/pub/linux/utils/nfs-utils/%{version}/%{name}-%{version}.tar.xz
Source1:		24-nfs-server.conf

Patch3000:		nfs-utils-1.2.1-statdpath-man.patch
Patch3001: 		nfs-utils-1.2.1-exp-subtree-warn-off.patch
Patch3002: 		nfs-utils-2.3.1-systemd-gssproxy-restart.patch
Patch3003: 		nfs-utils-2.3.3-man-tcpwrappers.patch
Patch3004: 		nfs-utils-2.3.3-nfsconf-usegssproxy.patch
Patch3005: 		nfs-utils-2.4.2-systemd-svcgssd.patch
Patch5000: 		5000-nfs-utils-2.6.1-nfsidmap-warnmsg.patch

BuildRequires:	make automake libtool gcc systemd rpcgen device-mapper-devel
BuildRequires:	libevent-devel libcap-devel libuuid-devel libtirpc-devel libblkid-devel
BuildRequires:	krb5-devel libmount-devel libxml2-devel sqlite-devel python3-devel
BuildRequires:	krb5-libs >= 1.4 
BuildRequires:	autoconf >= 2.57 
BuildRequires:	openldap-devel >= 2.2
Requires(pre):	util-linux coreutils
Requires(pre):	shadow-utils >= 4.0.3-25
Requires(preun): coreutils
Requires:		libnfsidmap libevent libblkid libcap libmount
Requires:		rpcbind sed gawk grep kmod keyutils quota python3-pyyaml
Requires:		libtirpc >= 0.2.3-1
Requires:		gssproxy >= 0.7.0-3
%{?systemd_requires}
Provides:		exportfs    = %{version}-%{release}
Provides:		showmount   = %{version}-%{release}
Provides:		rpcdebug    = %{version}-%{release}
Provides: 		rpcctl      = %{version}-%{release}
Provides: 		rpc.idmapd  = %{version}-%{release}
Provides: 		rpc.mountd  = %{version}-%{release}
Provides: 		rpc.nfsd    = %{version}-%{release}
Provides: 		rpc.statd   = %{version}-%{release}
Provides: 		rpc.gssd    = %{version}-%{release}
Provides: 		mount.nfs   = %{version}-%{release}
Provides: 		mount.nfs4  = %{version}-%{release}
Provides: 		umount.nfs  = %{version}-%{release}
Provides: 		umount.nfs4 = %{version}-%{release}
Provides: 		sm-notify   = %{version}-%{release}
Provides: 		start-statd = %{version}-%{release}
Provides: 		mountstats  = %{version}-%{release}
Provides: 		nfsidmap    = %{version}-%{release}
Provides: 		nfsstat     = %{version}-%{release}
Provides: 		nfsiostat   = %{version}-%{release}

%description
The nfsd filesystem is a special filesystem which provides access to the 
Linux NFS server. Writing to files in this filesystem can affect the server.  
Reading from them can provide information about the server.

As well as this filesystem, there are a collection of files in the procfs 
filesystem (normally mounted at /proc) which are used to control the NFS server.

The exportfs and mountd programs (part of the nfs-utils package) expect to find
this filesystem mounted at /proc/fs/nfsd or /proc/fs/nfs.

%package -n libnfsidmap
Summary:		Library to help mapping id's, mainly for NFSv4.
BuildRequires:	pkgconfig openldap-devel automake libtool
Requires:		openldap
Provides:		libnfsidmap = %{version}-%{release}

%description -n libnfsidmap
Library that handles mapping between names and ids for NFSv4.

When NFSv4 is using AUTH_GSS (which currently only supports Kerberos v5), 
the NFSv4 server mapping functions MUST use secure communications.

%package -n libnfsidmap-devel
Summary:		Development files for the libnfsidmap library
Requires:		libnfsidmap = %{version}-%{release}
Requires:		pkgconfig

%description -n libnfsidmap-devel
This package includes header files and libraries necessary for
developing programs which use the libnfsidmap library.

%prep
%autosetup -p1

%build
sh -x autogen.sh
%configure \
    CFLAGS="%{build_cflags} -D_FILE_OFFSET_BITS=64" \
    LDFLAGS="%{build_ldflags}" \
    --enable-mountconfig \
    --enable-ipv6 \
	--enable-libmount-mount \
	--enable-junction \
	--with-statdpath=%{_sharedstatedir}/nfs/statd \
	--with-systemd \
	--with-pluginpath=%{_libdir}/libnfsidmap \
	--without-tcp-wrappers

%make_build all

cp utils/mount/nfsmount.conf utils/mount/10-nfsv4.conf
sed -i 's/^# \(Nfsvers\).*/\1=4/g' utils/mount/10-nfsv4.conf

%install
%make_install

mkdir -p %{buildroot}%{_libexecdir}/nfs-utils/
mkdir -p %{buildroot}%{_sysconfdir}/exports.d
mkdir -p %{buildroot}%{_sysconfdir}/request-key.d
mkdir -p %{buildroot}%{_sysconfdir}/gssproxy
mkdir -p %{buildroot}%{_sysconfdir}/nfsmount.conf.d
install -m 644 utils/mount/nfsmount.conf %{buildroot}%{_sysconfdir}
install -m 644 nfs.conf %{buildroot}%{_sysconfdir}
install -m 644 support/nfsidmap/idmapd.conf %{buildroot}%{_sysconfdir}
install -m 644 utils/nfsidmap/id_resolver.conf %{buildroot}%{_sysconfdir}/request-key.d
install -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/gssproxy
install -m 644 utils/mount/10-nfsv4.conf %{buildroot}%{_sysconfdir}/nfsmount.conf.d
install -s -m 755 tools/rpcdebug/rpcdebug %{buildroot}%{_sbindir}

mkdir -p %{buildroot}%{_sharedstatedir}/nfs/rpc_pipefs
mkdir -p %{buildroot}%{_sharedstatedir}/nfs/statd/sm
mkdir -p %{buildroot}%{_sharedstatedir}/nfs/statd/sm.bak
mkdir -p %{buildroot}%{_sharedstatedir}/nfs/v4recovery
touch %{buildroot}%{_sharedstatedir}/nfs/rmtab

rm -f %{buildroot}%{_libdir}/*.{a,la}
rm -f %{buildroot}%{_libdir}/libnfsidmap/*.{a,la}

pushd %{buildroot}%{_sbindir}
cp -a %{buildroot}/sbin/* .
rm -rf %{buildroot}/sbin
popd

%pre
for x in gssd idmapd ; do
    if [ -f /var/lock/subsys/rpc.$x ]; then
		mv /var/lock/subsys/rpc.$x /var/lock/subsys/rpc$x
    fi
done

cat /etc/group | cut -d':' -f 1 | grep -q rpcuser 2>/dev/null
if [ "$?" -eq 1 ]; then
    /usr/sbin/groupadd -g %{rpcuser_uid} rpcuser >/dev/null 2>&1 || :
fi

cat /etc/passwd | cut -d':' -f 1 | grep -q rpcuser 2>/dev/null
if [ "$?" -eq 1 ]; then
    /usr/sbin/useradd -l -c "RPC Service User" -r -g %{rpcuser_uid} \
        -s /sbin/nologin -u %{rpcuser_uid} -d /var/lib/nfs rpcuser >/dev/null 2>&1 || :
else
    /usr/sbin/usermod -u %{rpcuser_uid} -g %{rpcuser_uid} rpcuser >/dev/null 2>&1 || :
fi 

cat /etc/group | cut -d':' -f 3 | grep -q %{nfsnobody_uid} 2>/dev/null
if [ "$?" -eq 1 ]; then
    /usr/sbin/groupadd -g %{nfsnobody_uid} nfsnobody >/dev/null 2>&1 || :
fi

cat /etc/passwd | cut -d':' -f 3 | grep -q %{nfsnobody_uid} 2>/dev/null
if [ $? -eq 1 ]; then
    /usr/sbin/useradd -l -c "Anonymous NFS User" -r -g %{nfsnobody_uid} \
		-s /sbin/nologin -u %{nfsnobody_uid} -d /var/lib/nfs nfsnobody >/dev/null 2>&1 || :
fi

%post
if [ $1 -eq 1 ] ; then
	/bin/systemctl enable nfs-client.target >/dev/null 2>&1 || :
	/bin/systemctl start nfs-client.target  >/dev/null 2>&1 || :
fi

%systemd_post nfs-server

%preun
if [ $1 -eq 0 ]; then
	%systemd_preun nfs-client.target
	%systemd_preun nfs-server.service

    rm -rf /var/lib/nfs/statd
    rm -rf /var/lib/nfs/v4recovery
	rm -rf /etc/nfsmount.conf.d
fi

%postun
%systemd_postun_with_restart  nfs-client.target
%systemd_postun_with_restart  nfs-server
/bin/systemctl --system daemon-reload >/dev/null 2>&1 || :

%triggerin -- nfs-utils > 2.6.2-1
/bin/systemctl try-restart gssproxy || :

%files
%license COPYING
%doc linux-nfs/{ChangeLog,KNOWNBUGS,NEW,README,THANKS,TODO}
%dir %{_sysconfdir}/exports.d
%config(noreplace) %{_sysconfdir}/nfsmount.conf
%attr(0600,root,root) %config(noreplace) %{_sysconfdir}/nfsmount.conf.d/10-nfsv4.conf
%config(noreplace) %{_sysconfdir}/nfs.conf
%attr(0600,root,root) %config(noreplace) %{_sysconfdir}/gssproxy/24-nfs-server.conf
%dir %{_sharedstatedir}/nfs
%dir %{_sharedstatedir}/nfs/v4recovery
%config(noreplace) %{_sharedstatedir}/nfs/etab
%config(noreplace) %{_sharedstatedir}/nfs/rmtab
%dir %attr(555, root, root) %{_sharedstatedir}/nfs/rpc_pipefs
%dir %attr(700,rpcuser,rpcuser) %{_sharedstatedir}/nfs/statd
%dir %attr(700,rpcuser,rpcuser) %{_sharedstatedir}/nfs/statd/sm
%dir %attr(700,rpcuser,rpcuser) %{_sharedstatedir}/nfs/statd/sm.bak
%ghost %attr(644,rpcuser,rpcuser) %{_sharedstatedir}/nfs/statd/state
%dir %{_libexecdir}/nfs-utils
%config(noreplace) %{_sysconfdir}/request-key.d/id_resolver.conf
%attr(0600,root,root) %config(noreplace) %{_udevrulesdir}/60-nfs.rules
%{_systemd_util_dir}/*/*
%{_udevrulesdir}/99-nfs.rules

%{_sbindir}/exportfs
%{_sbindir}/nfsdcltrack
%{_sbindir}/nfsstat
%{_sbindir}/rpcdebug
%{_sbindir}/rpcctl
%{_sbindir}/rpc.statd
%{_sbindir}/rpc.mountd
%{_sbindir}/rpc.nfsd
%{_sbindir}/rpc.idmapd
%{_sbindir}/rpc.gssd
%{_sbindir}/showmount
%{_sbindir}/sm-notify
%{_sbindir}/start-statd
%{_sbindir}/mountstats
%{_sbindir}/nfsiostat
%{_sbindir}/nfsidmap
%{_sbindir}/blkmapd
%{_sbindir}/nfsconf
%{_sbindir}/nfsref
%{_sbindir}/nfsdcld
%{_sbindir}/nfsdclddb
%{_sbindir}/nfsdclnts
%{_sbindir}/fsidd
%{_libexecdir}/nfsrahead
%attr(4755,root,root) %{_sbindir}/mount.nfs
%{_sbindir}/mount.nfs4
%{_sbindir}/umount.nfs
%{_sbindir}/umount.nfs4

%{_mandir}/*/*

%files -n libnfsidmap
%doc support/nfsidmap/{AUTHORS,README,COPYING}
%config(noreplace) %{_sysconfdir}/idmapd.conf
%{_libdir}/libnfsidmap.so.*
%{_libdir}/libnfsidmap/*.so
%{_mandir}/man3/nfs4_uid_to_name.*

%files -n libnfsidmap-devel
%{_libdir}/pkgconfig/libnfsidmap.pc
%{_includedir}/nfsidmap.h
%{_includedir}/nfsidmap_plugin.h
%{_libdir}/libnfsidmap.so

%changelog
* Thu Aug 17 2023 kianli <kianli@tencent.com> - 2.6.3-1
- Upgrade to 2.6.3

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.6.2-4
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.6.2-3
- Rebuilt for OpenCloudOS Stream 23

* Tue Nov  1 2022 Xiaojie Chen <jackxjchen@tencent.com> 2.6.2-2
- Fix dependency problems with nfsdclnts

* Thu Aug 18 2022 Xiaojie Chen <jackxjchen@tencent.com> 2.6.2-1
- Initial build
